> ## Documentation Index
> Fetch the complete documentation index at: https://docs.chainstream.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Token - Liquidity Snapshots

> Retrieve historical liquidity snapshots for a token. If a time parameter is provided, returns the nearest snapshot before or at that time.



## OpenAPI

````yaml /en/api-reference/openapi-data-en.yaml GET /v2/token/{chain}/{tokenAddress}/liquiditySnapshots
openapi: 3.1.0
info:
  title: Services API
  description: Services API
  contact:
    name: AI
    email: ai@sx.ai
  license:
    name: MIT
  version: '1.0'
servers:
  - url: https://api.chainstream.io
    description: Production
security:
  - bearer_auth: []
  - api_key_auth: []
tags:
  - name: Blockchain
    description: Blockchain related operations
  - name: Token
    description: Token related operations
  - name: Trade
    description: Trade related operations
  - name: Wallet
    description: Wallet related operations
  - name: Dex
    description: Dex related operations
  - name: Ranking
    description: Ranking related operations
  - name: DexPool
    description: DexPool related operations
  - name: Watchlist
    description: Watchlist related operations
  - name: KYT
    description: Kyt related operations
  - name: Webhook
    description: Webhook related operations
  - name: RedPacket
    description: Redpacket related operations
  - name: IPFS
    description: Ipfs related operations
  - name: DexScreener
    description: DexScreener related operations
paths:
  /v2/token/{chain}/{tokenAddress}/liquiditySnapshots:
    get:
      tags:
        - Token
      summary: Token - Liquidity Snapshots
      description: >-
        Retrieve historical liquidity snapshots for a token. If a time parameter
        is provided, returns the nearest snapshot before or at that time.
      operationId: get.token.liquidity.snapshots
      parameters:
        - name: chain
          in: path
          description: A chain name listed in supported networks
          required: true
          schema:
            $ref: '#/components/schemas/ChainSymbol'
          example: sol
        - name: tokenAddress
          in: path
          description: An address of a token
          required: true
          schema:
            type: string
          example: 113FvWQTBC7CXtgSvzfxRSedwVkLbmD8WfAjFrbpump
        - name: cursor
          in: query
          description: Pagination cursor
          required: false
          schema:
            type: string
          example: eyJpZCI6IjEyMyJ9
        - name: limit
          in: query
          description: Number of results per page
          required: false
          schema:
            type: integer
            format: int64
            default: 20
          example: 20
        - name: direction
          in: query
          description: Pagination direction (next or prev)
          required: false
          schema:
            oneOf:
              - $ref: '#/components/schemas/PageDirection'
            default: next
          example: next
        - name: time
          in: query
          description: Target Unix timestamp for liquidity snapshot query
          required: false
          schema:
            type: integer
            format: int64
          example: 1770336000000
      responses:
        '200':
          description: Get Liquidity Snapshots
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PageResponse_TokenLiquiditySnapshot'
components:
  schemas:
    ChainSymbol:
      type: string
      description: Supported blockchain chains
      enum:
        - sol
        - eth
        - bsc
    PageDirection:
      type: string
      description: Pagination direction
      enum:
        - next
        - prev
    PageResponse_TokenLiquiditySnapshot:
      type: object
      description: Generic pagination response
      required:
        - data
      properties:
        data:
          type: array
          items:
            type: object
            description: Token liquidity snapshot
            required:
              - snapshotTime
              - maxLiquidityPoolAddress
              - maxLiquidityInUsd
              - maxLiquidityInNative
              - totalLiquidityInUsd
              - totalLiquidityInNative
              - poolCount
              - priceUsd
              - priceNative
              - calculatedAt
            properties:
              calculatedAt:
                type: integer
                format: int64
                description: Snapshot calculation timestamp (milliseconds)
                example: 1705312800000
              maxLiquidityInNative:
                type: string
                description: Maximum pool liquidity in native token
                example: '5000.123'
              maxLiquidityInUsd:
                type: string
                description: Maximum pool liquidity in USD
                example: '1000000.45'
              maxLiquidityPoolAddress:
                type: string
                description: Address of the pool with maximum liquidity
                example: 58oQChx4yWmvKdwLLZzBi4ChoCc2fqCUWBkwMihLYQo2
              poolCount:
                type: integer
                format: int64
                description: Number of active liquidity pools
                example: 5
              priceNative:
                type: string
                description: Token price in native token at snapshot time
                example: '0.005'
              priceUsd:
                type: string
                description: Token price in USD at snapshot time
                example: '1.0001'
              snapshotTime:
                type: integer
                format: int64
                description: Snapshot timestamp (milliseconds)
                example: 1705312800000
              totalLiquidityInNative:
                type: string
                description: Total liquidity across all pools in native token
                example: '10000.246'
              totalLiquidityInUsd:
                type: string
                description: Total liquidity across all pools in USD
                example: '2000000.90'
          description: Page data
        endCursor:
          type:
            - string
            - 'null'
          description: Cursor for the end of current page
          example: eyJpZCI6ImVuZCJ9
        hasNext:
          type: boolean
          description: Whether there is a next page
          example: false
        hasPrev:
          type: boolean
          description: Whether there is a previous page
          example: false
        startCursor:
          type:
            - string
            - 'null'
          description: Cursor for the start of current page
          example: eyJpZCI6InN0YXJ0In0=
        total:
          type:
            - integer
            - 'null'
          format: int64
          description: >-
            Total number of items matching the query (not just the current
            page).

            When `None`, the caller should treat it as unknown
            (backward-compatible).
          example: 564094
  securitySchemes:
    bearer_auth:
      type: http
      scheme: bearer
      bearerFormat: JWT
    api_key_auth:
      type: apiKey
      in: header
      name: X-API-KEY

````